﻿package {
	import flash.geom.Point;
	import flash.display.MovieClip;
	import RotPoint;
	public class MoveController {
		public var partition:Number; // 点と点の間の分割量
		
		public var points:Array; // 移動するポイントのリスト
		public var total:Number; // 点の総数
		
		public function MoveController() {
			partition = 10;
			points = new Array();
			total = 0;
		}
		
		/* 点を追加 */
		public function addPoint(x:Number, y:Number, rotation:Number):Number{
			this.points.push(new RotPoint(x, y, rotation));
			// trace("AddPoint: "+this.points.length+" ("+x+", "+y+", "+rotation+")");
			this.total = 1+this.partition*(this.points.length-1);
			return total;
		}
		
		/* 移動する線を表示する */
		public function drawPoints():void{
			
		}
		
		/* 指定位置にMCを移動させる */
		public function moveMC(mc:MovieClip, pos:int):RotPoint{
			if(total <= pos || pos < 0) return null; // この点は出ねえよ
			var p:RotPoint;
			if(total-1 == pos){ // 最後の点の時
				p = points[points.length-1];
				mc.x = p.x;
				mc.y = p.y;
				mc.rotation = p.rotation;
				//trace("moveMC: "+pos+"(last) ("+p.x+", "+p.y+", "+p.rotation+")");
				return p;
			}
			else{
				var line:int = Math.floor(pos/partition); // どの辺か
				var i = pos%partition; // どの分割位置か
				
				var pb:RotPoint = points[line+1];
				var pa:RotPoint = points[line];
				var x = (pb.x-pa.x)/partition*i+pa.x;
				var y = (pb.y-pa.y)/partition*i+pa.y;
				var rotation = (pb.rotation-pa.rotation)/partition*i+pa.rotation;
				p = new RotPoint(x,y,rotation);
				
				mc.x = x;
				mc.y = y;
				mc.rotation = rotation;
				//trace("moveMC: "+pos+" ("+p.x+","+p.y+","+p.rotation+")");
				return p;
			}
		}
	}

}